
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS完全自学手册——［三］Objective－C语言速成，利用Objective－C创建自己的对象 / 憋错料</title>

    <meta name="description" content="iOS完全自学手册——［三］Objective－C语言速成，利用Objective－C创建自己的对象 1.前言 上一篇已经介绍了App Delegate.View Controller的基本概念,除此之外,分别利用storyboard和纯代码创建了第一个Xcode的工程,并对不同方式搭建项目进行了比较.这一篇文章,我准备为大家介绍一下奇葩的Objective-C语言的语法和使用.这篇文章主要讲Objective-C的理论概念. 2.学习目标 2.1 Objective-C语言面向对象的特性与其他语言(C++)类比学习,声明定义一个MyObject类,并创建这个类的实例. 2.2 Objectiv">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS完全自学手册——［三］Objective－C语言速成，利用Objective－C创建自己的对象</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>1.前言</p>
<p>上一篇已经介绍了App Delegate、View Controller的基本概念，除此之外，分别利用storyboard和纯代码创建了第一个Xcode的工程，并对不同方式搭建项目进行了比较。这一篇文章，我准备为大家介绍一下奇葩的Objective－C语言的语法和使用。这篇文章主要讲Objective－C的理论概念。</p>
<p>2.学习目标</p>
<p>2.1 Objective－C语言面向对象的特性与其他语言（C++）类比学习，声明定义一个MyObject类，并创建这个类的实例。</p>
<p>2.2 Objective－C语言常见语法概念概览。[协议，分类，扩展,消息机制，动态特性selector，KVC，KVO，block，ARC]</p>
<p>3.奇葩的Objective－C语言</p>
<p>对于已经有开发经验的开发者而言，初次接触Objective－C的时候觉得根本不能接受，甚至有种畏惧，oc奇葩的语法简直颠覆了自己的世界观，因为出现了莫名其妙的符号，如， ＋ － ［ ］。但是，不要怕，我们慢慢来了解这到底是毛线。</p>
<p>首先，从名字即可看出，Objective－C是一个面向对象的编程语言，也就是它和其他面向对象的语言一样有继承、封装、多态的语言特性，学习的时候可以类比其他语言。当然，如果没接触过其他语言也没关系，那就直接学。那么，就用C++和Objective－C两种语言去声明定义一个MyObject类。</p>
<p>3.1 先看一下C++中声明定义类是如何编写的</p>
<p>3.1.1 C++程序源码</p>
<pre>#include &lt;iostream&gt;
using namespace std;
class MyObject {
public:
    MyObject();
    ~MyObject();
    void display();
    void setValue(int x);
    int getIndex();
    int getKey();
    static void classMethod();
private:
    int index;
    int key;
};

MyObject::MyObject() {
    cout&lt;&lt;"construct"&lt;&lt;endl;
}

MyObject::~MyObject() {
    cout&lt;&lt;"destruct"&lt;&lt;endl;
}

void MyObject::setValue(int x) {
    this-&gt;index = x;
    this-&gt;key = 1&lt;&lt;(x+2);
}

void MyObject::display() {
    cout&lt;&lt;"index == "&lt;&lt;this-&gt;index&lt;&lt;endl;
    cout&lt;&lt;"key == "&lt;&lt;this-&gt;key&lt;&lt;endl;
}

int MyObject::getKey() {
    return this-&gt;key;
}

int MyObject::getIndex() {
    return this-&gt;index;
}

void MyObject::classMethod() {
    cout&lt;&lt;"this is static (or class) method"&lt;&lt;endl;
}

int main(int argc, const char * argv[]) {
    // insert code here...
    std::cout &lt;&lt; "Hello, World!\n";

    MyObject *object = new MyObject();
    MyObject::classMethod();
    object-&gt;setValue(3);
    object-&gt;display();
    int c = object-&gt;getIndex() + object-&gt;getKey();
    object-&gt;MyObject::~MyObject();
    printf("c = %d\n", c);

    MyObject object2;
    object2.setValue(2);
    object2.display();

    return 0;
}</pre>
<p>3.1.2 控制台打印信息</p>
<p><strong>Hello, World!</strong></p>
<p><strong>construct</strong></p>
<p><strong>this is static (or class) method</strong></p>
<p><strong>index == 3</strong></p>
<p><strong>key == 32</strong></p>
<p><strong>destruct</strong></p>
<p><strong>c = 35</strong></p>
<p><strong>construct</strong></p>
<p><strong>index == 2</strong></p>
<p><strong>key == 16</strong></p>
<p><strong>destruct</strong></p>
<p><strong>Program ended with exit code: 0</strong></p>
<p>3.1.3 代码解释：</p>
<p>以上代码利用C++声明定义了MyObject类</p>
<p><strong>1）定义了公有方法方法</strong>：</p>
<ul>
<li>构造函数MyObject()</li>
<li>析构函数~MyObject()</li>
<li>打印index和key的方法display()</li>
<li>设置私有变量方法setValue(int x)</li>
<li>获得index值方法getIndex()</li>
<li>获得key方法getKey()</li>
<li>类方法classMethod()</li>
</ul>
<p><strong>2）定义了私有成员变量</strong>：</p>
<ul>
<li>index和key</li>
</ul>
<p>3.1.4 特别注意</p>
<ul>
<li>构造函数是创建实例时调用的，在这个方法中可以为实例进行初始化操作；</li>
<li>析构函数是销毁实例对象是被系统调用的，这里可以将对象中的指针对象都delete掉；</li>
<li>不管是否使用new关键字创建对象，系统都会<strong>自动调用构造函数和析构函数，构造函数实质是为对象在内存分配一个空间，存储这个对象的数据，而析构函数则是将这个对象占用的内存释放掉</strong><strong>。</strong></li>
<li><strong>使用new关键字创建对象时，调用对象的方法（或成员变量）使用&ldquo;-&gt;&rdquo;符号；不使用new关键字创建对象是，调用对象须使用&ldquo;.&rdquo;符号。</strong></li>
<li>类方法是静态方法，是在类装载的时候装载的。（但是要特别注意，类的静态变量是该类的对象所共有的，即是所有对象共享变量。所以建议尽量少用静态变量。尽量在静态方法中使用内部变量。）</li>
</ul>
<p>3.2 再看一下Objective－C是如何定义一个MyObject类的</p>
<p>3.2.1 创建新项目</p>
<p>选择OS X中的Command Line Tool，创建好工程后，按住command＋N键创建Cocoa Touch Class，创建一个名为MyObject的NSObject的子类。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzQwMjE2NC8yMDE2MDEvNDAyMTY0LTIwMTYwMTEwMTY1OTI0OTgxLTU3OTc1MDk5OS5wbmc=.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzQwMjE2NC8yMDE2MDEvNDAyMTY0LTIwMTYwMTEwMTY1OTQzNDAzLTEwMTI0OTg5NjgucG5n.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzQwMjE2NC8yMDE2MDEvNDAyMTY0LTIwMTYwMTEwMTcwMTA1MjYyLTEzNDE3MTE2NzQucG5n.jpg" /></p>
<p>这样就创建了OS X的命令行程序，以用于简单演示如何声明定义Objective－C的类</p>
<p>3.2.2 程序源码</p>
<p>1）main.m文件：</p>
<pre>#import &lt;Foundation/Foundation.h&gt;

#import "MyObject.h"

int main(int argc, const char * argv[]) {
    @autoreleasepool {
        // insert code here...
        NSLog(@"Hello, World!");
        MyObject *object = [[MyObject alloc] initWithIndex:3];
        [object display];
//        object = nil;
    }
    return 0;
}</pre>
<p>2)&nbsp;MyObject.h</p>
<pre>#import &lt;Foundation/Foundation.h&gt;

@interface MyObject : NSObject
- (instancetype)initWithIndex:(NSInteger)index;
- (void)display;
+ (void)classMethod;
@end</pre>
<p>3) .m文件</p>
<pre>#import "MyObject.h"

@interface MyObject()
@property (assign, nonatomic) NSInteger index;
@property (assign, nonatomic) NSInteger key;

@end

@implementation MyObject
@synthesize index = _index;
@synthesize key = _key;

- (instancetype)initWithIndex:(NSInteger)index {
    self = [super init];
    if (self) {
        NSLog(@"init");
        self.index = index;
    }
    return self;
}

- (void)setIndex:(NSInteger)index {
    _index = index;
    self.key = 1&lt;&lt;(index+2);
}

- (NSInteger)index {
    return _index;
}

- (NSInteger)key {
    return _key;
}

- (void)display {
    NSLog(@"index == %ld \n key == %ld", (long)_index, (long)_key);
}

+ (void)classMethod {
    NSLog(@"this is static (or class) method");
}

- (void)dealloc {
    NSLog(@"dealloc");
}
@end</pre>
<p>3.2.3 控制台打印结果</p>
<p><strong>2016-01-10 17:55:50.401 CompileOC[20792:1052939] Hello, World!</strong></p>
<p><strong>2016-01-10 17:55:50.402 CompileOC[20792:1052939] init</strong></p>
<p><strong>2016-01-10 17:55:50.402 CompileOC[20792:1052939] index == 3&nbsp;</strong></p>
<p><strong>&nbsp;key == 32</strong></p>
<p><strong>2016-01-10 17:55:50.402 CompileOC[20792:1052939] dealloc</strong></p>
<p><strong>Program ended with exit code: 0</strong></p>
<p>3.2.4 代码解释</p>
<p>1） 在main.m文件中创建了MyObject的实例并调用display方法。</p>
<p>2）在头文件中声明了三个公有方法，</p>
<p>- (instancetype)initWithIndex:(NSInteger)index;</p>
<p>- (void)display;</p>
<p>+ (void)classMethod;</p>
<p>3）.m文件中</p>
<ul>
<li>创建了一个MyObject类的扩展，在扩展中声明了两个NSInteger的属性，属性的特性为assign和nonatomic</li>
<li>重写了父类中的实例（减号）init方法，并为index属性赋值</li>
<li>实现了index属性的setter方法</li>
<li>实现了index和key属性的getter方法</li>
<li>创建了打印index和key的方法<br />
<br />- (void)display</li>
<li>创建了类方法<br />
<br />+ (void)classMethod;</li>
<li>重写了父类的dealloc方法</li>
</ul>
<p>4）与C++代码做对比</p>
<ul>
<li>在C++中可以创建没有父类的类，但是在Objective－C中创建的类都继承自NSObject或其子类。不选择父类的话是不能创建Objective－</li>
<li>在C++中调用方法或变量用&ldquo;-&gt;&rdquo;或&ldquo;.&rdquo;符号，而在Objective－C中调用方法是[]，而且顺序不是从左至右，而是从内到外</li>
<li>在C++中声明公有方法用public关键字表明， 私有方法用private表明。而在Objective－C中声明公有方法只要在头文件的<br />
<br />@interface</p>
<p>@end<br />之间就可以了,而私有方法不需要在头文件中声明。</li>
<li>补充，在Objective－C中可以使用@private @public @protected @package 编译器指令来设置实例变量的访问限制。<br />实例变量的声明方式为，<br />
<br />@implementation {<br />&nbsp; &nbsp; &nbsp; &nbsp; @private<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; int index;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; int key;<br />}<br />@end<br />　　</li>
<li>注意实例变量和类的属性并不是一回事，属性和实例变量的本质区别是，属性无法直接访问对象的内部状态，但是可以利用setter和getter方法进行访问，而在setter和getter方法中还可以包含其他逻辑，比如，本文章中
<p>- (void)setIndex:(NSInteger)index<br />方法，不单为实例变量_index赋值，还用setter的简洁方式</p>
<p>self.key = 1&lt;&lt;(index+2);<br />为实例变量_key赋值。</li>
<li>那_index和_key实例变量是谁声明的呢？这是Xcode编译器自己生成的：
<p>@synthesize index = _index;</p>
<p>@synthesize key = _key;<br />上面的代码使用了&nbsp;@synthesize 编译指令，让编译器分别为属性index和key自动创建实例变量_index和_key。即，自动为属性创建对应实例变量的方法是&nbsp;<br />@synthesize&nbsp;属性名 = 实例变量名;<br />事实上，当没有实现setter方法时，@synthesize指令不写，编译器也可以为属性自动创建实例变量，编译器自动为属性创建的变量名默认为_属性名，在调试的时候可以设置变量观察。</li>
<li>注意本程序是在Xcode7中创建运行的，Xcode5之后创建工程时就默认ARC模式了，现在基本项目都是自动引用计数的模式编写的。老项目中的使用手动管理的需要做如下的设置：<br />在targets的build phases选项下Compile Sources下选择要不使用arc编译的文件，双击它，输入<code>-fno-objc-arc</code>即可</li>
<li>在项目开发中，我认为属性远比实例变量好用，大可以只声明属性，而不声明实例变量。</li>
</ul>
<p>4.Objective－C语言常见语法概念</p>
<p>4.1 基本语法概念</p>
<p>4.1.1类元素<br />1）实例变量</p>
<p>声明方法：</p>
<p>@implementation {<br />&nbsp; &nbsp; &nbsp; &nbsp;//声明实例变量<br />}<br />@end</p>
<p>实例变量是是类封装的数据</p>
<p>2）属性</p>
<p>@property (特性) 类型&nbsp;属性名;</p>
<p>属性是Objective－C提供的访问对象共享状态的机制，编译器可以自动生成访问实例变量的方法。Xcode自动创建的实例变量默认变量名为&ldquo;_属性名&rdquo;</p>
<p>3）类的声明（接口）</p>
<p>@interface MyObject : NSObject</p>
<p>@end</p>
<p>通用的如下：</p>
<p>@interface&nbsp;类名 : 父类名</p>
<p>@end</p>
<p>说明：</p>
<ul>
<li>@interface 和 @end 指令之间的区域只能声明属性或方法，不能有具体的实现过程。</li>
<li>如果在头文件中的接口声明的属性或方法，其实就是公有的属性和方法，可以直接访问。</li>
</ul>
<p>4）类的实现</p>
<p>@implementation {</p>
<p>//实例变量的声明</p>
<p>}</p>
<p>//属性和方法的定义</p>
<p>@end</p>
<p>说明：</p>
<ul>
<li>方法的实现过程必须写在&nbsp;@implementation 和&nbsp;@end 之间</li>
</ul>
<p>5）类的方法：分为类方法和实例方法。</p>
<ul>
<li>声明：</p>
<p>[+或－](返回类型)方法名:(参数类型)参数1 参数名:(参数类型)参数2 ... 参数名:(参数类型)参数n;</li>
</ul>
<ul>
<li>实现：</p>
<p>[+或－](返回类型)方法名:(参数类型)参数1 参数名2:(参数类型)参数2 ... 参数名n:(参数类型)参数n {</li>
</ul>
<p>//code here</p>
<p>return 返回值;</p>
<p>}</p>
<ul>
<li>调用：<br />[消息接收者（即类的实例对象） 方法名:1&nbsp;&nbsp;参数名2:2 ... &nbsp;参数名n:n];</li>
</ul>
<p>说明：</p>
<ul>
<li>方法的声明其实就是方法部分实现除了{}以外的代码</li>
<li>Objective－C的方法定义方式很奇葩，刚开始不好接受，这其实是Objective－C独有的消息机制一种体现。
<ul>
<li>在其他语言中，方法的书写方式是函数式的，类似于数学中的函数f(x,y,z)。</li>
<li>在Objective－C中调用方法时向消息的接收者（类的实例对象）发送一条消息，书写形式为[消息接收者 消息方法名:参数1 参数名2:参数2]，所有调用方法都是动态的，根据发出消息的方法名来动态查找对应的指针。感兴趣的话可以参考罗朝辉大神的博客&nbsp;http://blog.csdn.net/kesalin/article/details/6689226<br />
<br />&ldquo;不同的类可以拥有相同的 selector，这个没有问题，因为不同类的实例对象performSelector相同的 selector 时，会在各自的消息选标(selector)/实现地址(address) 方法链表中根据 selector 去查找具体的方法实现IMP, 然后用这个方法实现去执行具体的实现代码。这是一个动态绑定的过程，在编译的时候，我们不知道最终会执行哪一些代码，只有在执行的时候，通过selector去查询，我们才能确定具体的执行代码。&rdquo;</li>
</ul>
</li>
<li>多参数的声明、实现和调用。例如，我在MyObject中定义一个多参数的请求方法：<br />
<br />- (void)requestDataWithIndex:(NSInteger)index forKey:(NSInteger)key completion:(void(^)(NSError *error, id response))completion {</p>
<p>//code here</p>
<p>NSError *responseError = nil;//assume it is responsed from server</p>
<p>NSDictionary *responseData = @{@"message": @"OK"};</p>
<p>if (completion != nil) {</p>
<p>if (responseError != nil) {</p>
<p>completion(responseError, nil);</p>
<p>} else {</p>
<p>completion(nil, responseData);</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>说明：</p>
<ul>
<li>- (void)requestDataWithIndex:(NSInteger)index forKey:(NSInteger)key completion:(void(^)(NSError&nbsp;*error,&nbsp;id&nbsp;response))completion直接可以复制到@interface 和 @end 之间作为方法的声明</li>
<li>注意方法中第三个参数是block，这个后面会稍作介绍，先了解概念混个眼熟，以后慢慢细琢磨。block是一块代码块，实质是闭包，程序运行时，block{}内的不会立即执行，即非顺序执行的，是异步执行的，所以最适合选为做网络异步请求的回调函数，功能类似于ajax。</li>
</ul>
</li>
</ul>
<p>6）类的扩展</p>
<p>其实就是写在类.m文件中的接口，只不过与类.h中接口相比，在.m文件中声明的实例变量、属性、方法外部不能访问，即实现了方法、属性的私有化。例如MyObject.m文件中</p>
<p>@interface MyObject()</p>
<p>@property (assign, nonatomic) NSInteger index;</p>
<p>@property (assign, nonatomic) NSInteger key;</p>
<p>@end</p>
<p>这段代码就是扩展，并且声明的index和key属性外部不能访问，只能在类的内部访问。</p>
<p>7）分类</p>
<p>分类的目的主要是为了扩展类的方法，比如MyObject类我添加一个NY的分类，创建方法如下：</p>
<ul>
<li>command＋N 选择iOS Source中的Objective－C File，Next</li>
<li>填写File（分类名），选择category，class 填写MyObject，然后点Next，再点Create创建</li>
<li>头文件：</li>
</ul>

<pre>#import "MyObject.h"

@interface MyObject (NY)

@end</pre>

<ul>
<li>实现文件</li>
</ul>

<pre>#import "MyObject+NY.h"

@implementation MyObject (NY)

@end</pre>
<p>说明：</p>
<ul>
<li>分类中只可以声明和定义方法，不可以声明类接口属性或实例变量。因为已经引用了原来类的头文件会报重复声明类的语法错误。</li>
</ul>
<p>/Users/niyao/GitHub/demo/CompileOC/CompileOC/MyObject+NY.m:10:1: Duplicate interface definition for class ‘MyObject‘</p>
<p>8）协议</p>
<ul>
<li>协议的声明定义</li>
</ul>
<p>@protocol NYProtocol &lt;NSObject&gt;</p>
<p>@optional</p>
<p>- (void)nyOptionalProtocalMethod;</p>
<p>@required</p>
<p>- (void)nyRequiredProtocalMethod;</p>
<p>@end</p>
<p>通用：</p>
<p>@protocol&nbsp;协议名 &lt;NSObject&gt;</p>
<p>@optional</p>
<p>//可选择实现的方法</p>
<p>@required</p>
<p>//必须实现的方法</p>
<p>@end</p>
<ul>
<li>类遵从协议的方法</li>
</ul>
<p>@interface MyObject() &lt;NYProtocol&gt;</p>
<p>@property (assign, nonatomic) NSInteger index;</p>
<p>@property (assign, nonatomic) NSInteger key;</p>
<p>@end</p>
<p>说明：</p>
<ul>
<li>协议的定义可以写写在类的头文件中也可以写在类的实现文件中，或者也可以创建一个单独的协议头文件，但是必须要写在遵从该协议的类接口之前，否则会报语法错误</li>
<li>@optional指令标明的方法，遵从该协议的类不须要实现，但@required指令标明的必须实现</li>
<li>只有类的接口后面可以跟&lt;协议&gt;&nbsp;@interface&nbsp;MyObject() &lt;NYProtocol&gt;</li>
</ul>
<p>4.2 ARC（Automatic Reference Counting）</p>
<p>系统根据对象被引用的次数计次，当引用计数为零时，释放该对象所占有的内存。</p>
<p>4.3 KVC&amp;KVO</p>
<p>博文推荐<br />http://blog.csdn.net/kesalin/article/details/8155245</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-03 15:50:42 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS完全自学手册——［三］Objective－C语言速成，利用Objective－C创建自己的对象的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jXOje4.html" rel="bookmark">iOS完全自学手册&mdash;&mdash;［一］Ready？No！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.前言 今天开始我会不定期写一些iOS自学的相关文章.毕竟,自己是自学开始,知道自学有哪些坑,知道自学对于开发欠缺什么,此外,加上现在的实际开发经验,希望能给自学的iOS开发者一些建议. 2.Ready? 2.1 工欲善其事,必先利其器 —— 务必要有自己的 Mac 微博上 @不知霜舞哀伤udspj (http://weibo.com/udspj ,公众号 udspj_manga )妹纸画过一副图,关于iOS新手的建议,漫画上给的回复是“不要怕花钱”.我很认,舍不得孩子套不着狼,没有Mac干毛			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kXJ1d3.html" rel="bookmark">iOS完全自学手册&mdash;&mdash;［二］Hello World</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.前言 写第二篇文章之前,我在想第二篇应该怎么写?后来觉得与其写Objective-C语言的相关语法,不如直接开始写个小项目.语法简单入门即可.因为,即便把语法看的很深到最后还是不一定能做项目,运用到项目中去.那就从HelloWorld开始吧. 2.?学习目标 1)用Storyboard和纯代码实现Hello World简单应用,了解iOS项目的创建流程. 2)了解 AppDelegate 3)了解 View Controller 3.创建HelloWorld工程 1)用storyboard创			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyNo7n0.html" rel="bookmark">iOS第三方库汇总［转载］</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS第三方库汇总［转载］ 字数2179 阅读334 评论0 喜欢29 简介 此文用于总结,本人使用过或者收藏过的Github第三方类库,以便日后查阅,也便他人借鉴. 资料整理中不定期更新... 开源项目 CodeHub browse and maintain your GitHub repositories on any iOS device! Open-Source iOS Apps 开源iOS apps列表 APP相关 iVersion 提示版本更新 BonMot 字体相关的库,设置字体样			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZDyOgM.html" rel="bookmark">［XMPP］iOS聊天软件学习笔记［三］</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天做了好友界面,其实xmpp内部已经写好很多扩展模块,所以使用起来还是很方便的 开发时间:五天(工作时间) 开发工具:xcode6 开发平台:iOS8 XMPP框架:XMPPFramework git clone https://github.com/robbiehanson/XMPPFramework.git 界面设计:使用StoryBoard github地址:https://github.com/hjandyz/XMPP 1.每一个模块创建以后都需要激活,比如自动连接模块 //自动连接模			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rkKXb4.html" rel="bookmark">Nginx自学手册（三）location匹配，rewrite</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(一)Nginx location location语法规则 Syntax: location [ = | ~ | ~* | ^~ ] uri { ... }location @name { ... } Default: - Context: server, location nginx官方的例子: location = / {     [ configuration A ] } location / {     [ configuration B ] } location /documents			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDXre8M.html" rel="bookmark">［转］iOS学习之UINavigationController详解与使用&lpar;三&rpar;ToolBar</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载地址:http://blog.csdn.net/totogo2010/article/details/7682641 iOS学习之UINavigationController详解与使用(二)页面切换和segmentedController 接上篇,我们接着讲Navigation 的Toolbar. 1.显示Toolbar  在RootViewController.m的- (void)viewDidLoad方法中添加代码,这样Toobar就显示出来了. [cpp] view plaincopy			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDd2E8M.html" rel="bookmark">［转］iOS应用程序生命周期&lpar;前后台切换&comma;应用的各种状态&rpar;详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载地址:http://blog.csdn.net/totogo2010/article/details/8048652 iOS的应用程序的生命周期,还有程序是运行在前台还是后台,应用程序各个状态的变换,这些对于开发者来说都是很重要的. iOS系统的资源是有限的,应用程序在前台和在后台的状态是不一样的.在后台时,程序会受到系统的很多限制,这样可以提高电池的使用和用户体验. //开发app,我们要遵循apple公司的一些指导原则,原则如下: 1.应用程序的状态 状态如下: Not running			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDvqqp3.html" rel="bookmark">［转］在iOS项目中使用CorePlot框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载地址:http://blog.csdn.net/llfjfz/article/details/7849190#comments Core Plot是OS X和IOS下的一个开源图形库,它提供数据的可视化处理,就是画曲线图.柱状图和饼图等等.如何在项目中使用Core Plot的静态库呢?以下是几个步骤: 首先先去Google Code下载Core Plot图形库,网址 http://code.google.com/p/core-plot/ .目前该网址提供了CorePlot_1.0.zip下载			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jAnDDM.html" rel="bookmark">［转］iOS学习之UINavigationController详解与使用&lpar;二&rpar;页面切换和segmentedController</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载地址:http://blog.csdn.net/totogo2010/article/details/7682433 iOS学习之UINavigationController详解与使用(一)添加UIBarButtonItem是上篇,我们接着讲UINavigationController的重要作用,页面的管理和切换. 1.RootView 跳到SecondView 首先我们需要新一个View.新建SecondView,按住Command键然后按N,弹出新建页面,我们新建SecondView 2			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knvqpM.html" rel="bookmark" class="title">数组定义与用法&comma;</a>
					<div>
						指针是变量 地址和指针的区别地址是常量指针是变量 指针变量加1,其结果相当于加1个其指向类型所占的字节数. 两个数相加整形向浮点看齐,整形向指针看齐. 指针是地址变量数组名是地址常量.int a[5] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVg6Yp0.html" rel="bookmark" class="title">使用curl解压gzip的内容</a>
					<div>
						好久没写博客了,今天心血来潮,记录一下今天解决的一个问题. curl设置了CURLOPT_ACCEPT_ENCODING (7.21.8之前为CURLOPT_ENCODING )之后,按照官方的说法, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqvvw0.html" rel="bookmark" class="title">&lpar;转&rpar;如何使用Java、Servlet创建二维码</a>
					<div>
						归功于智能手机,QR码逐渐成为主流,它们正变得越来越有用.从候车亭.产品包装.家装卖场.汽车到很多网站,都在自己的网页集成QR码,让人们快速找到它们.随着智能手机的用户量日益增长,二维码的使用正在呈指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OaWdGM.html" rel="bookmark" class="title">DOM Element节点类型详解</a>
					<div>
						1.概况 Element 类型用于表现 HTML 或 XML 元素,提供了对元素标签名.子节点及特性的访问. Element 节点具有以下特征: nodeType 的值为 1 nodeName 的值为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pemJVM.html" rel="bookmark" class="title">Merge Two Sorted Lists &amp;amp&semi; Remove Nth Node From End of List</a>
					<div>
						1.合并两个排好序的list Merge Two Sorted Lists Merge two sorted linked lists and return it as a new list. The ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONWe90.html" rel="bookmark" class="title">定制EditText</a>
					<div>
						步骤一: 创建CustomEditTextActivity类 package com.example; import android.app.Activity;import android.os.Bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/382m9RM.html" rel="bookmark" class="title">OSChina 周二乱弹 &mdash;&mdash; 生男生女一样好</a>
					<div>
						五四青年节你们有放假吗?小小编要厚颜无耻地告诉你们,OSC 有放假哦,你们赶紧来膜拜红薯吧!哈哈~ 好了,继续拉仇恨的话我就要挨揍了.先说件高兴的事,永和当爹了~~~ @OSC叶童:红薯开赌场了--  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqxNYM.html" rel="bookmark" class="title">JavaScript 内容串联 ---Document</a>
					<div>
						Document 对象 一.找到对象document.getElementById(&quot;id&quot;);//根据id找,最多找出一个,因为ID是唯一的:document.getELemen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wjDdY0.html" rel="bookmark" class="title">Struts1&period;x 基本原理及注册模块的实现</a>
					<div>
						1.编写JavaBean:User,必须继承于ActionForm类 1 package myuser; 2 3 import org.apache.struts.action.ActionForm; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPKav4.html" rel="bookmark" class="title">mysql分表的三种方法</a>
					<div>
						mysql分表的3种方法 一,先说一下为什么要分表 当一张的数据达到几百万时,你查询一次所花的时间会变多,如果有联合查询的话,我想有可能会死在那儿了.分表的目的就在于此,减小数据库的负担,缩短查询时间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZkxn3.html" rel="bookmark" class="title">daemon方式创建rsync</a>
					<div>
						(1)服务端 vi /etc/rsyncd.conf  //创建配置文件,输入以下内容 #rsync_config_______________start #created by oldboy 15: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezWLp3.html" rel="bookmark" class="title">various types available in JNI</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qOpp9M.html" rel="bookmark" class="title">学习oracle</a>
					<div>
						下载oracle 网址http://www.oracle.com/technetwork/index.html 根据你的机型选择下载安装不同版本,首先你得注册一个oracle账户才能下载. 官网EX  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBjrlAM.html" rel="bookmark" class="title">学习进度条 第六周</a>
					<div>
						  第六周 学习时间(h) 上课时间:4 编程时间:14 阅读时间:2 代码量(行) 200 博客量(篇) 1 所学到的知识点 1.本周编程主要在四则运算器中,对java 语言有了更加熟练的理解. 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME1kAKM.html" rel="bookmark" class="title">&lpar;转徐明吉&rpar;C&num;生成随机数</a>
					<div>
						1 private static char[] constant = 2 { 3 '0','1','2','3','4','5','6','7','8','9', 4 'a','b','c','d', ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47zEE13.html" rel="bookmark" class="title">数据结构与算法课程练习01-最大子序列和问题</a>
					<div>
						01最大子序列和问题 给定K个整数组成的序列{ N1, N2, ..., NK },“连续子列”被定义为{ Ni, Ni+1, ..., Nj },其中 1 &lt;= i &lt;= j &lt;= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k6Qz7M.html" rel="bookmark" class="title">class和Class</a>
					<div>
						class是关键字 Class是类,在Java中,每个class都有一个相应的Class对象.也就是说,当我们编写一个类,编译完成后,在生成的.class文件中,就会产生一个 Class对象,用于表示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLQWnE0.html" rel="bookmark" class="title">还能再来过？</a>
					<div>
						不能. 生活的现实告诉我们,我们的关于重新再来的豪言壮语只是无法实现的自我安慰,多数情况下,失败所带来的连锁反应,就算是你做了充分的补救,也会让你自觉无力. 人生啊!比如说我,在我搞砸了我人生中的一次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBD1Ev3.html" rel="bookmark" class="title">常见移动web注意点</a>
					<div>
						欢迎补充. 视口 &lt;meta name=&quot;viewport&quot; content=&quot;width=device-width, user-scalable=no, init ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVm9Zx4.html" rel="bookmark" class="title">第一节作业  飞机游戏体会 150206118</a>
					<div>
						首先说说我的感觉,这是我第一次接触这么完整的或者说是有些有趣的C语言程序.给我眼前一亮的感觉.不过当我看到程序的时候,不禁还是让我有些惊讶的--程序好长啊! 可是老师跟我们说其实这还是不算多的,而且用 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
